# Ihr Optimierer
# Argumente:
# f - Zielfunktion
# a0 - linke Grenze
# b0 - rechte Grenze
# maxIterations - Stopkriterium
# callback - Funktion zum Visualisieren
goldenSectionSearch <- function(f, a0, b0, maxIterations, callback=NULL) {


#   _   _   _   _     _   _   _   _   _   _   _   _   _   _   _   _   _   _   #
#  / \ / \ / \ / \   / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \  #
# ( h | i | e | r ) ( i | m | p | l | e | m | e | n | t | i | e | r | e | n ) #
#  \_/ \_/ \_/ \_/   \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/ \_/  #
#                                                                             #


}


# Die drei Zielfunktionen:
zf1 <- function(x) {
    return(x ** 3 + 9 * x ** 2 - 36 *x + 36)
}

zf2 <- function(x) {
    return(abs(x) - 0.5 * x)
}

zf3 <- function(x) {
    return(x^2 - 10 * cos(10*x))
}


# Hilfsfunktion zum Zeichnen; sollte in jeder Iteration des Optimierers aufgerufen werden
# Argumente: Nummer der aktuellen Iteration, Vektor mit (vier) x-Werten der Einschliessung
plotCurrentValues <- function(iteration, xValues) {
    cat(iteration, xValues, "\n")
    colorNumbers = c(10, 24, 26, 33, 38, 44, 66, 99, 144, 257, 313, 622, 68)
    # waehle irgendeine Farbe
    color <- colors()[colorNumbers[(iteration %% length(colorNumbers)) + 1]]
    # berechne Funktionswerte zum Zeichnen (zaehlen nicht als Kosten)
    yValues <- sapply(xValues, objective)
    maxY <- max(yValues)
    # zeichne in aktuelle Grafik
    lines(xValues, rep(maxY, length(xValues)), col=color)
    points(xValues, rep(maxY, length(xValues)), col=color, pch="|")
    for (i in 1:length(xValues)) {
        lines(rep(xValues[i], 2), c(yValues[i], maxY), col=color, lty=2)
    }
}


# Konfiguration  ##################################################################
optimizer <- goldenSectionSearch
# hier aendern fuer andere Aufgabenteile:
objective <- zf1
lBound <- -10
rBound <- 10
###################################################################################


# PDF oeffnen
pdf("ausgabe.pdf")
# Zielfunktion plotten (nur zur Anschauung), erzeugt neue Zeichenflaeche
plot(objective, xlim=c(lBound, rBound))
# Optimierer laufen lassen
result <- optimizer(objective, lBound, rBound, 15, plotCurrentValues)
# Ergebnis einzeichnen
points(result, objective(result), col="red")
# PDF schliessen
dev.off()
# noch mal finalen x-Wert auf Konsole ausgeben
cat("Ergebnis:", result, objective(result), "\n")


